## GtkImage

GtkImage — A widget displaying an image

## Functions

void | gtk_image_get_icon_set ()
GdkPixbuf * | gtk_image_get_pixbuf ()
void | gtk_image_get_stock ()
GdkPixbufAnimation * | gtk_image_get_animation ()
void | gtk_image_get_icon_name ()
void | gtk_image_get_gicon ()
GtkImageType | gtk_image_get_storage_type ()
GtkWidget * | gtk_image_new_from_file ()
GtkWidget * | gtk_image_new_from_icon_set ()
GtkWidget * | gtk_image_new_from_pixbuf ()
GtkWidget * | gtk_image_new_from_stock ()
GtkWidget * | gtk_image_new_from_animation ()
GtkWidget * | gtk_image_new_from_icon_name ()
GtkWidget * | gtk_image_new_from_gicon ()
GtkWidget * | gtk_image_new_from_resource ()
GtkWidget * | gtk_image_new_from_surface ()
void | gtk_image_set_from_file ()
void | gtk_image_set_from_icon_set ()
void | gtk_image_set_from_pixbuf ()
void | gtk_image_set_from_stock ()
void | gtk_image_set_from_animation ()
void | gtk_image_set_from_icon_name ()
void | gtk_image_set_from_gicon ()
void | gtk_image_set_from_resource ()
void | gtk_image_set_from_surface ()
void | gtk_image_clear ()
GtkWidget * | gtk_image_new ()
void | gtk_image_set_pixel_size ()
gint | gtk_image_get_pixel_size ()

## Properties

gchar * | file | Read / Write
GIcon * | gicon | Read / Write
gchar * | icon-name | Read / Write
GtkIconSet * | icon-set | Read / Write
gint | icon-size | Read / Write
GdkPixbuf * | pixbuf | Read / Write
GdkPixbufAnimation * | pixbuf-animation | Read / Write
gint | pixel-size | Read / Write
gchar * | resource | Read / Write
gchar * | stock | Read / Write
GtkImageType | storage-type | Read
CairoSurface * | surface | Read / Write
gboolean | use-fallback | Read / Write

## Types and Values

struct | GtkImage
enum | GtkImageType

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkMisc
                    ╰── GtkImage

## Implemented Interfaces

GtkImage implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkImage widget displays an image. Various kinds of object can be displayed as an image; most typically, you would load a GdkPixbuf ("pixel buffer") from a file, and then display that. There’s a convenience function to do this, `gtk_image_new_from_file()`, used as follows:

    1
    2

    GtkWidget *image;
    image = gtk_image_new_from_file ("myfile.png");

If the file isn’t loaded successfully, the image will contain a “broken image” icon similar to that used in many web browsers. If you want to handle errors in loading the file yourself, for example by displaying an error message, then load the image with `gdk_pixbuf_new_from_file()`, then create the GtkImage with `gtk_image_new_from_pixbuf()`.

The image file may contain an animation, if so the GtkImage will display an animation (GdkPixbufAnimation) instead of a static image.

GtkImage is a subclass of GtkMisc, which implies that you can align it (center, left, right) and add padding to it, using GtkMisc methods.

GtkImage is a “no window” widget (has no GdkWindow of its own), so by default does not receive events. If you want to receive events on the image, such as button clicks, place the image inside a GtkEventBox, then connect to the event signals on the event box.

#### Handling button press events on a GtkImage.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33

    static gboolean
    button_press_callback (GtkWidget      *event_box,
                           GdkEventButton *event,
                           gpointer        data)
    {
      g_print ("Event box clicked at coordinates %f,%f\n",
               event->x, event->y);

      // Returning TRUE means we handled the event, so the signal
      // emission should be stopped (don’t call any further callbacks
      // that may be connected). Return FALSE to continue invoking callbacks.
      return TRUE;
    }

    static GtkWidget*
    create_image (void)
    {
      GtkWidget *image;
      GtkWidget *event_box;

      image = gtk_image_new_from_file ("myfile.png");

      event_box = gtk_event_box_new ();

      gtk_container_add (GTK_CONTAINER (event_box), image);

      g_signal_connect (G_OBJECT (event_box),
                        "button_press_event",
                        G_CALLBACK (button_press_callback),
                        image);

      return image;
    }

When handling events on the event box, keep in mind that coordinates in the image may be different from event box coordinates due to the alignment and padding settings on the image (see GtkMisc). The simplest way to solve this is to set the alignment to 0.0 (left/top), and set the padding to zero. Then the origin of the image will be the same as the origin of the event box.

Sometimes an application will want to avoid depending on external data files, such as image files. GTK+ comes with a program to avoid this, called “gdk-pixbuf-csource”. This library allows you to convert an image into a C variable declaration, which can then be loaded into a GdkPixbuf using `gdk_pixbuf_new_from_inline()`.

### CSS nodes

GtkImage has a single CSS node with the name image. The style classes may appear on image CSS nodes: .icon-dropshadow, .lowres-icon.

## Functions

### gtk_image_get_icon_set ()

    void
    gtk_image_get_icon_set (GtkImage *image,
                            GtkIconSet **icon_set,
                            GtkIconSize *size);

`gtk_image_get_icon_set` has been deprecated since version 3.10 and should not be used in newly-written code.

Use `gtk_image_get_icon_name()` instead.

Gets the icon set and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_ICON_SET` (see `gtk_image_get_storage_type()`).

#### Parameters

image | a GtkImage |
icon_set | location to store a GtkIconSet, or `NULL`. | [out][transfer none][allow-none]
size | location to store a stock icon size (GtkIconSize), or `NULL`. | [out][allow-none][type int]

### gtk_image_get_pixbuf ()

    GdkPixbuf *
    gtk_image_get_pixbuf (GtkImage *image);

Gets the GdkPixbuf being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_PIXBUF` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned pixbuf.

#### Parameters

image | a GtkImage |

#### Returns

the displayed pixbuf, or `NULL` if the image is empty.

[nullable][transfer none]

### gtk_image_get_stock ()

    void
    gtk_image_get_stock (GtkImage *image,
                         gchar **stock_id,
                         GtkIconSize *size);

`gtk_image_get_stock` has been deprecated since version 3.10 and should not be used in newly-written code.

Use `gtk_image_get_icon_name()` instead.

Gets the stock icon name and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_STOCK` (see `gtk_image_get_storage_type()`). The returned string is owned by the GtkImage and should not be freed.

#### Parameters

image | a GtkImage |
stock_id | place to store a stock icon name, or `NULL`. | [out][transfer none][allow-none]
size | place to store a stock icon size (GtkIconSize), or `NULL`. | [out][allow-none][type int]

### gtk_image_get_animation ()

    GdkPixbufAnimation *
    gtk_image_get_animation (GtkImage *image);

Gets the GdkPixbufAnimation being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_ANIMATION` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned animation.

#### Parameters

image | a GtkImage |

#### Returns

the displayed animation, or `NULL` if the image is empty.

[nullable][transfer none]

### gtk_image_get_icon_name ()

    void
    gtk_image_get_icon_name (GtkImage *image,
                             const gchar **icon_name,
                             GtkIconSize *size);

Gets the icon name and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_ICON_NAME` (see `gtk_image_get_storage_type()`). The returned string is owned by the GtkImage and should not be freed.

#### Parameters

image | a GtkImage |
icon_name | place to store an icon name, or `NULL`. | [out][transfer none][allow-none]
size | place to store an icon size (GtkIconSize), or `NULL`. | [out][allow-none][type int]

Since: 2.6

### gtk_image_get_gicon ()

    void
    gtk_image_get_gicon (GtkImage *image,
                         GIcon **gicon,
                         GtkIconSize *size);

Gets the GIcon and size being displayed by the GtkImage. The storage type of the image must be `GTK_IMAGE_EMPTY` or `GTK_IMAGE_GICON` (see `gtk_image_get_storage_type()`). The caller of this function does not own a reference to the returned GIcon.

#### Parameters

image | a GtkImage |
gicon | place to store a GIcon, or `NULL`. | [out][transfer none][allow-none]
size | place to store an icon size (GtkIconSize), or `NULL`. | [out][allow-none][type int]

Since: 2.14

### gtk_image_get_storage_type ()

    GtkImageType
    gtk_image_get_storage_type (GtkImage *image);

Gets the type of representation being used by the GtkImage to store image data. If the GtkImage has no image data, the return value will be `GTK_IMAGE_EMPTY`.

#### Parameters

image | a GtkImage |

#### Returns

image representation being used

### gtk_image_new_from_file ()

    GtkWidget *
    gtk_image_new_from_file (const gchar *filename);

Creates a new GtkImage displaying the file `filename` . If the file isn’t found or can’t be loaded, the resulting GtkImage will display a “broken image” icon. This function never returns `NULL`, it always returns a valid GtkImage widget.

If the file contains an animation, the image will contain an animation.

If you need to detect failures to load the file, use `gdk_pixbuf_new_from_file()` to load the file yourself, then create the GtkImage from the pixbuf. (Or for animations, use `gdk_pixbuf_animation_new_from_file()`).

The storage type (`gtk_image_get_storage_type()`) of the returned image is not defined, it will be whatever is appropriate for displaying the file.

#### Parameters

filename | a filename. | [type filename]

#### Returns

a new GtkImage

### gtk_image_new_from_icon_set ()

    GtkWidget *
    gtk_image_new_from_icon_set (GtkIconSet *icon_set,
                                 GtkIconSize size);

`gtk_image_new_from_icon_set` has been deprecated since version 3.10 and should not be used in newly-written code.

Use `gtk_image_new_from_icon_name()` instead.

Creates a GtkImage displaying an icon set. Sample stock sizes are GTK_ICON_SIZE_MENU, GTK_ICON_SIZE_SMALL_TOOLBAR. Instead of using this function, usually it’s better to create a GtkIconFactory, put your icon sets in the icon factory, add the icon factory to the list of default factories with `gtk_icon_factory_add_default()`, and then use `gtk_image_new_from_stock()`. This will allow themes to override the icon you ship with your application.

The GtkImage does not assume a reference to the icon set; you still need to unref it if you own references. GtkImage will add its own reference rather than adopting yours.

#### Parameters

icon_set | a GtkIconSet |
size | a stock icon size (GtkIconSize). | [type int]

#### Returns

a new GtkImage

### gtk_image_new_from_pixbuf ()

    GtkWidget *
    gtk_image_new_from_pixbuf (GdkPixbuf *pixbuf);

Creates a new GtkImage displaying `pixbuf` . The GtkImage does not assume a reference to the pixbuf; you still need to unref it if you own references. GtkImage will add its own reference rather than adopting yours.

Note that this function just creates an GtkImage from the pixbuf. The GtkImage created will not react to state changes. Should you want that, you should use `gtk_image_new_from_icon_name()`.

#### Parameters

pixbuf | a GdkPixbuf, or `NULL`. | [allow-none]

#### Returns

a new GtkImage

### gtk_image_new_from_stock ()

    GtkWidget *
    gtk_image_new_from_stock (const gchar *stock_id,
                              GtkIconSize size);

`gtk_image_new_from_stock` has been deprecated since version 3.10 and should not be used in newly-written code.

Use `gtk_image_new_from_icon_name()` instead.

Creates a GtkImage displaying a stock icon. Sample stock icon names are GTK_STOCK_OPEN, GTK_STOCK_QUIT. Sample stock sizes are GTK_ICON_SIZE_MENU, GTK_ICON_SIZE_SMALL_TOOLBAR. If the stock icon name isn’t known, the image will be empty. You can register your own stock icon names, see `gtk_icon_factory_add_default()` and `gtk_icon_factory_add()`.

#### Parameters

stock_id | a stock icon name |
size | a stock icon size (GtkIconSize). | [type int]

#### Returns

a new GtkImage displaying the stock icon

### gtk_image_new_from_animation ()

    GtkWidget *
    gtk_image_new_from_animation (GdkPixbufAnimation *animation);

Creates a GtkImage displaying the given animation. The GtkImage does not assume a reference to the animation; you still need to unref it if you own references. GtkImage will add its own reference rather than adopting yours.

Note that the animation frames are shown using a timeout with G_PRIORITY_DEFAULT. When using animations to indicate busyness, keep in mind that the animation will only be shown if the main loop is not busy with something that has a higher priority.

#### Parameters

animation | an animation |

#### Returns

a new GtkImage widget

### gtk_image_new_from_icon_name ()

    GtkWidget *
    gtk_image_new_from_icon_name (const gchar *icon_name,
                                  GtkIconSize size);

Creates a GtkImage displaying an icon from the current icon theme. If the icon name isn’t known, a “broken image” icon will be displayed instead. If the current icon theme is changed, the icon will be updated appropriately.

#### Parameters

icon_name | an icon name or `NULL`. | [nullable]
size | a stock icon size (GtkIconSize). | [type int]

#### Returns

a new GtkImage displaying the themed icon

Since: 2.6

### gtk_image_new_from_gicon ()

    GtkWidget *
    gtk_image_new_from_gicon (GIcon *icon,
                              GtkIconSize size);

Creates a GtkImage displaying an icon from the current icon theme. If the icon name isn’t known, a “broken image” icon will be displayed instead. If the current icon theme is changed, the icon will be updated appropriately.

#### Parameters

icon | an icon |
size | a stock icon size (GtkIconSize). | [type int]

#### Returns

a new GtkImage displaying the themed icon

Since: 2.14

### gtk_image_new_from_resource ()

    GtkWidget *
    gtk_image_new_from_resource (const gchar *resource_path);

Creates a new GtkImage displaying the resource file `resource_path` . If the file isn’t found or can’t be loaded, the resulting GtkImage will display a “broken image” icon. This function never returns `NULL`, it always returns a valid GtkImage widget.

If the file contains an animation, the image will contain an animation.

If you need to detect failures to load the file, use `gdk_pixbuf_new_from_file()` to load the file yourself, then create the GtkImage from the pixbuf. (Or for animations, use `gdk_pixbuf_animation_new_from_file()`).

The storage type (`gtk_image_get_storage_type()`) of the returned image is not defined, it will be whatever is appropriate for displaying the file.

#### Parameters

resource_path | a resource path |

#### Returns

a new GtkImage

Since: 3.4

### gtk_image_new_from_surface ()

    GtkWidget *
    gtk_image_new_from_surface (cairo_surface_t *surface);

Creates a new GtkImage displaying `surface` . The GtkImage does not assume a reference to the surface; you still need to unref it if you own references. GtkImage will add its own reference rather than adopting yours.

#### Parameters

surface | a cairo_surface_t, or `NULL`. | [allow-none]

#### Returns

a new GtkImage

Since: 3.10

### gtk_image_set_from_file ()

    void
    gtk_image_set_from_file (GtkImage *image,
                             const gchar *filename);

See `gtk_image_new_from_file()` for details.

#### Parameters

image | a GtkImage |
filename | a filename or `NULL`. | [type filename][allow-none]

### gtk_image_set_from_icon_set ()

    void
    gtk_image_set_from_icon_set (GtkImage *image,
                                 GtkIconSet *icon_set,
                                 GtkIconSize size);

`gtk_image_set_from_icon_set` has been deprecated since version 3.10 and should not be used in newly-written code.

Use `gtk_image_set_from_icon_name()` instead.

See `gtk_image_new_from_icon_set()` for details.

#### Parameters

image | a GtkImage |
icon_set | a GtkIconSet |
size | a stock icon size (GtkIconSize). | [type int]

### gtk_image_set_from_pixbuf ()

    void
    gtk_image_set_from_pixbuf (GtkImage *image,
                               GdkPixbuf *pixbuf);

See `gtk_image_new_from_pixbuf()` for details.

#### Parameters

image | a GtkImage |
pixbuf | a GdkPixbuf or `NULL`. | [allow-none]

### gtk_image_set_from_stock ()

    void
    gtk_image_set_from_stock (GtkImage *image,
                              const gchar *stock_id,
                              GtkIconSize size);

`gtk_image_set_from_stock` has been deprecated since version 3.10 and should not be used in newly-written code.

Use `gtk_image_set_from_icon_name()` instead.

See `gtk_image_new_from_stock()` for details.

#### Parameters

image | a GtkImage |
stock_id | a stock icon name |
size | a stock icon size (GtkIconSize). | [type int]

### gtk_image_set_from_animation ()

    void
    gtk_image_set_from_animation (GtkImage *image,
                                  GdkPixbufAnimation *animation);

Causes the GtkImage to display the given animation (or display nothing, if you set the animation to `NULL`).

#### Parameters

image | a GtkImage |
animation | the GdkPixbufAnimation |

### gtk_image_set_from_icon_name ()

    void
    gtk_image_set_from_icon_name (GtkImage *image,
                                  const gchar *icon_name,
                                  GtkIconSize size);

See `gtk_image_new_from_icon_name()` for details.

#### Parameters

image | a GtkImage |
icon_name | an icon name or `NULL`. | [nullable]
size | an icon size (GtkIconSize). | [type int]

Since: 2.6

### gtk_image_set_from_gicon ()

    void
    gtk_image_set_from_gicon (GtkImage *image,
                              GIcon *icon,
                              GtkIconSize size);

See `gtk_image_new_from_gicon()` for details.

#### Parameters

image | a GtkImage |
icon | an icon |
size | an icon size (GtkIconSize). | [type int]

Since: 2.14

### gtk_image_set_from_resource ()

    void
    gtk_image_set_from_resource (GtkImage *image,
                                 const gchar *resource_path);

See `gtk_image_new_from_resource()` for details.

#### Parameters

image | a GtkImage |
resource_path | a resource path or `NULL`. | [allow-none]

### gtk_image_set_from_surface ()

    void
    gtk_image_set_from_surface (GtkImage *image,
                                cairo_surface_t *surface);

See `gtk_image_new_from_surface()` for details.

#### Parameters

image | a GtkImage |
surface | a cairo_surface_t or `NULL`. | [nullable]

Since: 3.10

### gtk_image_clear ()

    void
    gtk_image_clear (GtkImage *image);

Resets the image to be empty.

#### Parameters

image | a GtkImage |

Since: 2.8

### gtk_image_new ()

    GtkWidget *
    gtk_image_new (void);

Creates a new empty GtkImage widget.

#### Returns

a newly created GtkImage widget.

### gtk_image_set_pixel_size ()

    void
    gtk_image_set_pixel_size (GtkImage *image,
                              gint pixel_size);

Sets the pixel size to use for named icons. If the pixel size is set to a value != -1, it is used instead of the icon size set by `gtk_image_set_from_icon_name()`.

#### Parameters

image | a GtkImage |
pixel_size | the new pixel size |

Since: 2.6

### gtk_image_get_pixel_size ()

    gint
    gtk_image_get_pixel_size (GtkImage *image);

Gets the pixel size used for named icons.

#### Parameters

image | a GtkImage |

#### Returns

the pixel size used for named icons.

Since: 2.6

## Types and Values

### struct GtkImage

    struct GtkImage;

This struct contain private data only and should be accessed by the functions below.

### enum GtkImageType

Describes the image data representation used by a GtkImage. If you want to get the image from the widget, you can only get the currently-stored representation. e.g. if the `gtk_image_get_storage_type()` returns GTK_IMAGE_PIXBUF, then you can call `gtk_image_get_pixbuf()` but not `gtk_image_get_stock()`. For empty images, you can request any storage type (call any of the "get" functions), but they will all return `NULL` values.

#### Members

GTK_IMAGE_EMPTY | there is no image displayed by the widget |
GTK_IMAGE_PIXBUF | the widget contains a GdkPixbuf |
GTK_IMAGE_STOCK | the widget contains a stock item name |
GTK_IMAGE_ICON_SET | the widget contains a GtkIconSet |
GTK_IMAGE_ANIMATION | the widget contains a GdkPixbufAnimation |
GTK_IMAGE_ICON_NAME | the widget contains a named icon. This image type was added in GTK+ 2.6 |
GTK_IMAGE_GICON | the widget contains a GIcon. This image type was added in GTK+ 2.14 |
GTK_IMAGE_SURFACE | the widget contains a cairo_surface_t. This image type was added in GTK+ 3.10 |

## Property Details

### The `“file”` property

      “file”                     gchar *

Filename to load and display.

Owner: GtkImage

Flags: Read / Write

Default value: NULL

### The `“gicon”` property

      “gicon”                    GIcon *

The GIcon displayed in the GtkImage. For themed icons, If the icon theme is changed, the image will be updated automatically.

Owner: GtkImage

Flags: Read / Write

Since: 2.14

### The `“icon-name”` property

      “icon-name”                gchar *

The name of the icon in the icon theme. If the icon theme is changed, the image will be updated automatically.

Owner: GtkImage

Flags: Read / Write

Default value: NULL

Since: 2.6

### The `“icon-set”` property

      “icon-set”                 GtkIconSet *

Icon set to display.

`GtkImage:icon-set` has been deprecated since version 3.10 and should not be used in newly-written code.

Use “icon-name” instead.

Owner: GtkImage

Flags: Read / Write

### The `“icon-size”` property

      “icon-size”                gint

Symbolic size to use for stock icon, icon set or named icon.

Owner: GtkImage

Flags: Read / Write

Allowed values: >= 0

Default value: 4

### The `“pixbuf”` property

      “pixbuf”                   GdkPixbuf *

A GdkPixbuf to display.

Owner: GtkImage

Flags: Read / Write

### The `“pixbuf-animation”` property

      “pixbuf-animation”         GdkPixbufAnimation *

GdkPixbufAnimation to display.

Owner: GtkImage

Flags: Read / Write

### The `“pixel-size”` property

      “pixel-size”               gint

The "pixel-size" property can be used to specify a fixed size overriding the “icon-size” property for images of type `GTK_IMAGE_ICON_NAME`.

Owner: GtkImage

Flags: Read / Write

Allowed values: >= -1

Default value: -1

Since: 2.6

### The `“resource”` property

      “resource”                 gchar *

A path to a resource file to display.

Owner: GtkImage

Flags: Read / Write

Default value: NULL

Since: 3.8

### The `“stock”` property

      “stock”                    gchar *

Stock ID for a stock image to display.

`GtkImage:stock` has been deprecated since version 3.10 and should not be used in newly-written code.

Use “icon-name” instead.

Owner: GtkImage

Flags: Read / Write

Default value: NULL

### The `“storage-type”` property

      “storage-type”             GtkImageType

The representation being used for image data.

Owner: GtkImage

Flags: Read

Default value: GTK_IMAGE_EMPTY

### The `“surface”` property

      “surface”                  CairoSurface *

A cairo_surface_t to display.

Owner: GtkImage

Flags: Read / Write

### The `“use-fallback”` property

      “use-fallback”             gboolean

Whether the icon displayed in the GtkImage will use standard icon names fallback. The value of this property is only relevant for images of type `GTK_IMAGE_ICON_NAME` and `GTK_IMAGE_GICON`.

Owner: GtkImage

Flags: Read / Write

Default value: FALSE

Since: 3.0

## See Also

GdkPixbuf